#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define HASHSIZE  7

// With 4 bits in the integer part
long xi = 0xf800000000000000; // -1
long yi = 0x0000000000000000; // 0
long ai[12];

int _a;
int _b;
long _mini;
long _maxi;
__int128 _round;
long _power;

void initializeA( int a, int b )
{
	_a = a;
	_b = b;

	_round = 1L;
	_round = _round << (b-1);
	_power = 1L << b;

	_mini = 1L << (a+b);
    _maxi = _mini - 1L;
    _mini = -_mini;
}

long setNumber( double v )
{
	return ( (long)(v*_power) );
}

double getNumber( long r )
{
	return ( (double)r/_power);
}

long multRound( long x, long y )
{
	long res;
	__int128 r;
	__int128 a=0;
	__int128 b=0;

	a = x;
	b = y;

	// r = a*b + _round;
	r = a*b;
	r = r>>_b;

	// res = 0xffffffffffffffff & r;
	res = r;

	return( res );
}

void initializeMap( int v  )
{
	// int i;
	// double map2[12] = { -1.0, 0.9, 0.4, -0.2, -0.6, -0.5, 0.4, 0.7, 0.3, -0.5, 0.7, -0.8 };

	initializeA( 4, 59 );

	/** for( i=0; i<12; i++ )
		ai[i] = setNumber( map2[i] );
	**/

	ai[0] = 0xf800000000000000;
	ai[1] = 0x0733333333333334;
	ai[2] = 0x0333333333333334;
	ai[3] = 0xfe66666666666666;
	ai[4] = 0xfb33333333333334;
	ai[5] = 0xfc00000000000000;
	ai[6] = 0x0333333333333334;
	ai[7] = 0x0599999999999998;
	ai[8] = 0x0266666666666666;
	ai[9] = 0xfc00000000000000;
	ai[10] = 0x0599999999999998;
	ai[11] = 0xf999999999999998;



	xi += v << 5;
}



unsigned int randomMap(  )
{
	// char xbits[81];
	unsigned int outbits=0;
	long xni, yni;
	long x2i, y2i, xyi;

	x2i = multRound( xi, xi );
	y2i = multRound( yi, yi );
	xyi = multRound( xi, yi );

	xni = ai[0] + multRound(ai[1],xi) + multRound(ai[2],x2i) + multRound(ai[3],xyi) +
	              multRound(ai[4],yi) + multRound(ai[5],y2i);
	yni = ai[6] + multRound(ai[7],xi) + multRound(ai[8],x2i) + multRound(ai[9],xyi) +
	              multRound(ai[10],yi) + multRound(ai[11],y2i);

	xi = xni;
	yi = yni;

	// Eight bits obtained every cycle:
	outbits = xni & 0x00000000000000ff;
	outbits = outbits << 8;
	outbits |= yni & 0x00000000000000ff; 

	return outbits;
}
